﻿Namespace edank.LGTV.Channels

    Public Class Satelitte

        Private _DataBlock As Byte() 'gesamter DatenBlock

        '*************************
        'DatenBlock Parts
        Private _Name As String
        Private _PositionInFile As Byte
        Private _Position2InFile As Byte
        Private tmp1() As Byte '10
        'EndDatenBlock Parts
        '****************************
        Private _Position As String


        Public Sub New(Data() As Byte)
            _DataBlock = Data

            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)


            Name = System.Text.Encoding.Default.GetString(br.ReadBytes(&H20))
            PositionInFile = br.ReadByte
            Position2InFile = br.ReadByte

            tmp1 = br.ReadBytes(10)

            br.Close()
            ms.Close()
            ms.Dispose()


        End Sub

        Public ReadOnly Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
        End Property

        Public Property Name As String
            Get
                Return _Name
            End Get
            Set(value As String)
                _Name = value.Replace(Chr(0), "")
            End Set
        End Property

        Private Property PositionInFile As Byte
            Get
                Return _PositionInFile
            End Get
            Set(value As Byte)
                _PositionInFile = value
                _Position = value.ToString("00")
            End Set
        End Property

        Private Property Position2InFile As Byte
            Get
                Return _Position2InFile
            End Get
            Set(value As Byte)
                _Position2InFile = value

                If CBool(value And &H10) Then
                    _Position &= String.Format(",{0} {1}", value - &H10, My.Resources.strSatPositionOst)
                Else
                    _Position &= String.Format(",{0} {1}", value, My.Resources.strSatPositionWest)
                End If
            End Set
        End Property

        Public Property Position As String
            Get
                Return _Position
            End Get
            Set(value As String)
                _Position = value
            End Set
        End Property

        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

    End Class

End Namespace