﻿Namespace edank.LGTV.Channels

    Public Class Transponder

        Private _DataBlock As Byte() 'gesamter DatenBlock

        '*************************
        'DatenBlock Parts
        Private tmp1() As Byte '10
        Private _ID As UInt16
        Private _Frequence As UInt16
        Private tmp2() As Byte '4
        Private _NID As UInt16
        Private _TID As UInt16
        Private tmp3() As Byte '3
        Private _Symbolrate_Polarisation As UInt16
        Private tmp4() As Byte '9
        Private _SatelitteIDInFile As Byte
        Private tmp5() As Byte '3
        'EndDatenBlock Parts
        '****************************
        Private _SatelitteID As Byte
        Private _Symbolrate As UInt16

        Public Sub New(Data() As Byte)
            _DataBlock = Data

            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)

            tmp1 = br.ReadBytes(10)
            _ID = br.ReadUInt16
            _Frequence = br.ReadUInt16
            tmp2 = br.ReadBytes(4)
            _NID = br.ReadUInt16
            _TID = br.ReadUInt16
            tmp3 = br.ReadBytes(3)
            Symbolrate_Polarisation = br.ReadUInt16
            tmp4 = br.ReadBytes(9)
            SatelitteIDInFile = br.ReadByte
            tmp5 = br.ReadBytes(3)
            br.Close()
            ms.Close()
            ms.Dispose()


        End Sub

        Public ReadOnly Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
        End Property

        Public Property ID As UInt16
            Get
                Return _ID
            End Get
            Set(value As UInt16)
                _ID = value
            End Set
        End Property

        Public Property Frequence As UInt16
            Get
                Return _Frequence
            End Get
            Set(value As UInt16)
                _Frequence = value
            End Set
        End Property

        Public Property NID As UInt16
            Get
                Return _NID
            End Get
            Set(value As UInt16)
                _NID = value
            End Set
        End Property

        Public Property TID As UInt16
            Get
                Return _TID
            End Get
            Set(value As UInt16)
                _TID = value
            End Set
        End Property

        Private Property Symbolrate_Polarisation As UInt16
            Get
                Return _Symbolrate_Polarisation
            End Get
            Set(value As UInt16)
                _Symbolrate_Polarisation = value
                _Symbolrate = CUShort(If((value And &H8000) = &H8000, value Xor &H8000, value) * 2)
            End Set
        End Property

        Public Property Symbolrate As UInt16
            Get
                Return _Symbolrate
            End Get
            Set(value As UInt16)
                _Symbolrate = value
            End Set
        End Property

        


        Private Property SatelitteIDInFile As Byte
            Get
                Return _SatelitteIDInFile
            End Get
            Set(value As Byte)
                _SatelitteIDInFile = value
                _SatelitteID = CByte(value / 2)
            End Set
        End Property

        Public Property SatelitteID As Byte
            Get
                Return _SatelitteID
            End Get
            Set(value As Byte)
                _SatelitteID = value
                _SatelitteIDInFile = CByte(value * 2)
            End Set
        End Property

        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

    End Class

End Namespace