﻿Imports edankTLL.edank
Imports edankTLL.edank.LGTV.Menu

Public Class frmHotelMenu

    Friend trs As Hotel

    Private Sub frmHotelMenu_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        cmbPowerOnStatus.BeginUpdate()
        cmbPowerOnStatus.Items.Add(New ComboItem(Hotel.ePowerOnStatus.LSD.ToString, Hotel.ePowerOnStatus.LSD))
        cmbPowerOnStatus.Items.Add(New ComboItem(Hotel.ePowerOnStatus.STD.ToString, Hotel.ePowerOnStatus.STD))
        cmbPowerOnStatus.Items.Add(New ComboItem(Hotel.ePowerOnStatus.PWR.ToString, Hotel.ePowerOnStatus.PWR))
        cmbPowerOnStatus.EndUpdate()

        cmbDTVChannelUpdate.BeginUpdate()
        cmbDTVChannelUpdate.Items.Add(New ComboItem(Hotel.eDTVChannelUpdate.Manual.ToString, Hotel.eDTVChannelUpdate.Manual))
        cmbDTVChannelUpdate.Items.Add(New ComboItem(Hotel.eDTVChannelUpdate.Auto.ToString, Hotel.eDTVChannelUpdate.Auto))
        cmbDTVChannelUpdate.EndUpdate()

        cmbInputSource.BeginUpdate()
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.Off.ToString, Hotel.eIOnputSource.Off))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.HDMI1.ToString, Hotel.eIOnputSource.HDMI1))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.HDMI2.ToString, Hotel.eIOnputSource.HDMI2))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.HDMI3.ToString, Hotel.eIOnputSource.HDMI3))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.HDMI4.ToString, Hotel.eIOnputSource.HDMI4))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.DTV.ToString, Hotel.eIOnputSource.DTV))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.Radio.ToString, Hotel.eIOnputSource.Radio))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.SDTV.ToString, Hotel.eIOnputSource.SDTV))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.S_Radio.ToString, Hotel.eIOnputSource.S_Radio))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.AV1.ToString, Hotel.eIOnputSource.AV1))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.AV2.ToString, Hotel.eIOnputSource.AV2))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.AV3.ToString, Hotel.eIOnputSource.AV3))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.Component.ToString, Hotel.eIOnputSource.Component))
        cmbInputSource.Items.Add(New ComboItem(Hotel.eIOnputSource.RGB.ToString, Hotel.eIOnputSource.RGB))
        cmbInputSource.EndUpdate()


        trs = DirectCast(Me.Owner, frmMain).mytll_ReadSave.HotelMenu
        chkHotelModeOperation.Checked = CBool(trs.HotelModeOperation)

        For Each ci As ComboItem In cmbPowerOnStatus.Items
            If ci.Data = trs.PowerOnStatus Then
                cmbPowerOnStatus.SelectedItem = ci
                Exit For
            End If
        Next



        chkSetupMenuDisplay.Checked = CBool(trs.SetupMenuDisplay)
        chkProgramChange.Checked = CBool(trs.ProgramChange)
        chkInputSourceChange.Checked = CBool(trs.InputSourceChange)

        'cmbProgramme.SelectedIndex = trs.Programme

        chkMenuDisplay.Checked = CBool(trs.MenuDisplay)
        chkOSDDisplay.Checked = CBool(trs.OSDDisplay)
        chkLGIROperation.Checked = CBool(trs.LGIROperatation)
        chkLocalKeyOperation.Checked = (CBool(trs.LocalKeyOperation) = False)

        nudMaxVolume.Value = trs.MaxVolume

        For Each ci As ComboItem In cmbDTVChannelUpdate.Items
            If ci.Data = trs.DTVChannelUpdate Then
                cmbDTVChannelUpdate.SelectedItem = ci
                Exit For
            End If
        Next

        chkPowerOnDefault.Checked = CBool(trs.PowerOnDefault)

        For Each ci As ComboItem In cmbInputSource.Items
            If ci.Data = trs.InputSource Then
                cmbInputSource.SelectedItem = ci
                Exit For
            End If
        Next

        If trs.Volume < 101 Then
            chkVolume.Checked = True
            nudVolume.Value = trs.Volume
        Else
            chkVolume.Checked = False
            nudVolume.Value = 0
        End If

        chkAVSetting.Checked = CBool(trs.AVSetting)
        chkRadioVideoBlank.Checked = CBool(trs.RadioVideoBlank)
        nudStartPrNo.Value = trs.StartPrNo
        nudNoOfPr.Value = trs.NoOfPr
        chkRadioNameDisplay.Checked = CBool(trs.RadioNameDisplay)

        nudHotelModePin.Value = trs.HotelModeCode
        lblHotelModePin.Text = "".PadLeft(4 - nudHotelModePin.Value.ToString.Length, CChar("0"))
    End Sub

    Private Sub butSave_Click(sender As System.Object, e As System.EventArgs) Handles butSave.Click

        trs.HotelModeOperation = CByte(If(chkHotelModeOperation.Checked, 1, 0))
        trs.PowerOnStatus = CType(DirectCast(cmbPowerOnStatus.SelectedItem, ComboItem).Data, Hotel.ePowerOnStatus)

        trs.SetupMenuDisplay = CByte(If(chkSetupMenuDisplay.Checked, 1, 0))
        trs.ProgramChange = CByte(If(chkProgramChange.Checked, 1, 0))
        trs.InputSourceChange = CByte(If(chkInputSourceChange.Checked, 1, 0))
        trs.MenuDisplay = CByte(If(chkMenuDisplay.Checked, 1, 0))
        trs.OSDDisplay = CByte(If(chkOSDDisplay.Checked, 1, 0))
        trs.LGIROperatation = CByte(If(chkLGIROperation.Checked, 1, 0))
        trs.LocalKeyOperation = CByte(If(chkLocalKeyOperation.Checked, 0, 1))
        trs.MaxVolume = CByte(nudMaxVolume.Value)
        trs.DTVChannelUpdate = CType(DirectCast(cmbDTVChannelUpdate.SelectedItem, ComboItem).Data, Hotel.eDTVChannelUpdate)
        trs.PowerOnDefault = CByte(If(chkPowerOnDefault.Checked, 1, 0))
        ' trs.InputSource = CType(DirectCast(cmbInputSource.SelectedItem, ComboItem).Data, Hotel.eIOnputSource)
        ' trs.Programme = CUShort(cmbProgramme.SelectedIndex)

        If chkVolume.Checked Then
            trs.Volume = CByte(nudVolume.Value)
        Else
            trs.Volume = 101
        End If

        trs.AVSetting = CByte(If(chkAVSetting.Checked, 1, 0))
        trs.RadioVideoBlank = CByte(If(chkRadioVideoBlank.Checked, 1, 0))

        'trs.StartPrNo = CByte(nudStartPrNo.Value)
        'trs.NoOfPr = CByte(nudNoOfPr.Value)
        trs.RadioNameDisplay = CByte(If(chkRadioNameDisplay.Checked, 1, 0))

        trs.HotelModeCode = CInt(nudHotelModePin.Value)

        Me.Close()

    End Sub

    Private Sub nudMaxVolume_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudMaxVolume.ValueChanged
        nudVolume.Maximum = nudMaxVolume.Value
    End Sub

    Private Sub nudHotelModePin_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudHotelModePin.ValueChanged
        lblHotelModePin.Text = "".PadLeft(4 - nudHotelModePin.Value.ToString.Length, CChar("0"))
    End Sub
End Class