﻿Namespace edank.LGTV.Channels

    Public Class DVBCT_Channel

        Private _DataBlock As Byte() 'gesamter DatenBlock

        '*************************
        'DatenBlock Parts
        Private tmp1() As Byte '10
        Private _TransponderChannel As Byte
        Private tmp2() As Byte '1
        Private _Number As UInt16
        Private tmp3() As Byte '6
        Private _FavByte As Byte
        Private tmp4() As Byte '3
        Private _AudioPid As UInt16
        Private tmp5() As Byte '4
        Private _NameInFile As String
        Private _NameLenght As Byte
        Private tmp6() As Byte '1
        Private _ServiceID_SID As UInt16
        Private tmp7() As Byte '16
        Private _TransponderChannel2 As Byte
        Private tmp8() As Byte '1
        Private _Frequency As UInt32
        Private tmp9() As Byte '2
        Private _OriginalNetworkID_ONID As UInt16
        Private _TransportStreamID_TSID As UInt16
        Private tmp10() As Byte '19
        Private _TransponderChannel3 As Byte
        Private tmp11() As Byte '2
        Private _Number2 As UInt16
        Private tmp12() As Byte '2
        Private _TransponderChannel4 As Byte
        Private tmp13() As Byte '1
        Private _FavByte2 As Byte
        Private _SkeepLockByte As Byte
        Private _ServiceID_SID2 As UInt16
        Private tmp14() As Byte '1
        Private _NameLenght2 As Byte
        Private _NameInFile2 As String
        Private tmp15() As Byte '2
        Private _AudioPid2 As UInt16
        Private tmp16() As Byte '4
        'EndDatenBlock Parts
        '****************************
        Private _DisplayName As String
        Private _DisplayName2 As String
        Private _isRadio As Boolean


        Public Sub New(Data() As Byte)
            _DataBlock = Data

            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)

            tmp1 = br.ReadBytes(10)
            _TransponderChannel = br.ReadByte
            tmp2 = br.ReadBytes(1)
            Number = br.ReadUInt16
            tmp3 = br.ReadBytes(6)
            _FavByte = br.ReadByte
            tmp4 = br.ReadBytes(3)
            _AudioPid = br.ReadUInt16
            tmp5 = br.ReadBytes(4)
            NameInFile = System.Text.Encoding.Default.GetString(br.ReadBytes(&H28))
            _NameLenght = br.ReadByte
            tmp6 = br.ReadBytes(1)
            _ServiceID_SID = br.ReadUInt16
            tmp7 = br.ReadBytes(16)
            _TransponderChannel2 = br.ReadByte
            tmp8 = br.ReadBytes(1)
            _Frequency = br.ReadUInt32
            tmp9 = br.ReadBytes(2)
            _OriginalNetworkID_ONID = br.ReadUInt16
            _TransportStreamID_TSID = br.ReadUInt16
            tmp10 = br.ReadBytes(19)
            _TransponderChannel3 = br.ReadByte
            tmp11 = br.ReadBytes(2)
            _Number2 = br.ReadUInt16
            tmp12 = br.ReadBytes(2)
            _TransponderChannel4 = br.ReadByte
            tmp13 = br.ReadBytes(1)
            _FavByte2 = br.ReadByte
            _SkeepLockByte = br.ReadByte
            _ServiceID_SID2 = br.ReadUInt16
            tmp14 = br.ReadBytes(1)
            _NameLenght2 = br.ReadByte
            _NameInFile2 = System.Text.Encoding.Default.GetString(br.ReadBytes(&H28))
            tmp15 = br.ReadBytes(2)
            _AudioPid2 = br.ReadUInt16
            tmp16 = br.ReadBytes(4)

            br.Close()
            ms.Close()
            ms.Dispose()

        End Sub
#Region "Properties"

        Public ReadOnly Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
        End Property

        Public Property Number As UInt16
            Get
                If Me.isRadio Then
                    Return CUShort(_Number - &H4000)
                Else
                    Return _Number
                End If
            End Get
            Set(value As UInt16)
                If CBool(value And &H4000) Then
                    Me._isRadio = True
                End If

                If Me.isRadio Then
                    _Number = CUShort(value Or &H4000)
                    _Number2 = CUShort(value Or &H4000)
                Else
                    _Number = value
                    _Number2 = value
                End If
            End Set
        End Property

        Public ReadOnly Property Number2 As UInt16
            Get
                Return _Number2
            End Get
        End Property

        Public Property NameInFile As String
            Get
                Return _NameInFile
            End Get
            Set(value As String)
                value = value.Replace(Chr(0), "")

                _NameInFile = value
                _NameInFile2 = value

                _DisplayName = value.Replace(Chr(&H86), "").Replace(Chr(&H87), "").Replace(Chr(&H5), "").Replace(Chr(&HB), "")
                _DisplayName2 = value.Replace(Chr(&H86), "").Replace(Chr(&H87), "").Replace(Chr(&H5), "").Replace(Chr(&HB), "")

                _NameLenght = CByte(value.Length)
                _NameLenght2 = CByte(value.Length)
            End Set
        End Property

        Public ReadOnly Property NameInFile2 As String
            Get
                Return _NameInFile2
            End Get
        End Property

        Public ReadOnly Property DisplayName As String
            Get
                Return _DisplayName
            End Get
        End Property

        Public ReadOnly Property DisplayName2 As String
            Get
                Return _DisplayName2
            End Get
        End Property

        Public ReadOnly Property NameLenght As Byte
            Get
                Return _NameLenght
            End Get
        End Property

        Public ReadOnly Property NameLenght2 As Byte
            Get
                Return _NameLenght2
            End Get
        End Property

        Public ReadOnly Property isRadio As Boolean
            Get
                Return _isRadio
            End Get
        End Property

        Public Property FavByte As Byte
            Get
                Return _FavByte
            End Get
            Set(value As Byte)
                _FavByte = value


                'FavByte2 alle FavoritenBits auf Null setzen
                If CBool(_FavByte2 And DVBCT_Channel.ChannelFavoriten2.A) Then _FavByte2 = _FavByte2 Xor DVBCT_Channel.ChannelFavoriten2.A
                If CBool(_FavByte2 And DVBCT_Channel.ChannelFavoriten2.B) Then _FavByte2 = _FavByte2 Xor DVBCT_Channel.ChannelFavoriten2.B
                If CBool(_FavByte2 And DVBCT_Channel.ChannelFavoriten2.C) Then _FavByte2 = _FavByte2 Xor DVBCT_Channel.ChannelFavoriten2.C
                If CBool(_FavByte2 And DVBCT_Channel.ChannelFavoriten2.D) Then _FavByte2 = _FavByte2 Xor DVBCT_Channel.ChannelFavoriten2.D

                'FavByte2 FavoritenBits setzen
                If CBool(value And DVBCT_Channel.ChannelFavoriten.A) Then
                    _FavByte2 = _FavByte2 Or DVBCT_Channel.ChannelFavoriten2.A
                End If

                If CBool(value And DVBCT_Channel.ChannelFavoriten.B) Then
                    _FavByte2 = _FavByte2 Or DVBCT_Channel.ChannelFavoriten2.B
                End If

                If CBool(value And DVBCT_Channel.ChannelFavoriten.C) Then
                    _FavByte2 = _FavByte2 Or DVBCT_Channel.ChannelFavoriten2.C
                End If

                If CBool(value And DVBCT_Channel.ChannelFavoriten.D) Then
                    _FavByte2 = _FavByte2 Or DVBCT_Channel.ChannelFavoriten2.D
                End If

            End Set
        End Property

        Public ReadOnly Property FavByte2 As Byte
            Get
                Return _FavByte2
            End Get
        End Property

        Public Property SkeepLockByte As Byte
            Get
                Return _SkeepLockByte
            End Get
            Set(value As Byte)
                _SkeepLockByte = value
            End Set
        End Property

        Public ReadOnly Property Frequency As UInt32
            Get
                Return _Frequency
            End Get
        End Property

        Public ReadOnly Property TransponderChannel As Byte
            Get
                Return _TransponderChannel
            End Get
        End Property

        Public ReadOnly Property TransponderChannel2 As Byte
            Get
                Return _TransponderChannel2
            End Get
        End Property

        Public ReadOnly Property TransponderChannel3 As Byte
            Get
                Return _TransponderChannel3
            End Get
        End Property

        Public ReadOnly Property TransponderChannel4 As Byte
            Get
                Return _TransponderChannel4
            End Get
        End Property

        Public ReadOnly Property ServiceID_SID As UInt16
            Get
                Return _ServiceID_SID
            End Get
        End Property

        Public ReadOnly Property ServiceID_SID2 As UInt16
            Get
                Return _ServiceID_SID2
            End Get
        End Property

        Public ReadOnly Property OriginalNetworkID_ONID As UInt16
            Get
                Return _OriginalNetworkID_ONID
            End Get
        End Property

        Public ReadOnly Property TransportStreamID_TSID As UInt16
            Get
                Return _TransportStreamID_TSID
            End Get
        End Property

        Public ReadOnly Property AudioPid As UInt16
            Get
                Return _AudioPid
            End Get
        End Property

        Public ReadOnly Property AudioPid2 As UInt16
            Get
                Return _AudioPid2
            End Get
        End Property

#End Region

        Public Enum ChannelFavoriten As Byte
            A = &H1
            B = &H2
            C = &H4
            D = &H8
        End Enum

        Public Enum ChannelFavoriten2 As Byte
            A = &H4
            B = &H8
            C = &H10
            D = &H20
        End Enum

        Public Enum ChannelSkipLockMode As Byte
            Lock = &H9
            Skip = &H2
        End Enum





        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

        Public Function getBlockDatatoSave() As String
            Dim r As String = ""
            Dim d() As Byte = getDataToSave()
            For i As Integer = 0 To d.Length - 1
                r &= d(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

        Public Function getDataToSave() As Byte()

            Dim ms As New IO.MemoryStream()
            Dim bw As New IO.BinaryWriter(ms)


            bw.Write(tmp1)

            bw.Write(TransponderChannel)

            bw.Write(tmp2)

            Dim x As Int16 = CShort(Number Or &H4000)
            If isRadio Then
                bw.Write(x)
            Else
                bw.Write(Number)
            End If

            bw.Write(tmp3)

            bw.Write(FavByte)

            bw.Write(tmp4)
            bw.Write(AudioPid)
            bw.Write(tmp5)

            'Name
            For i As Integer = 0 To NameInFile.Length - 1
                bw.Write(Convert.ToByte(Asc(NameInFile.Substring(i, 1))))
            Next
            For i As Integer = 0 To 40 - 1 - NameInFile.Length
                bw.Write(CByte(0))
            Next

            bw.Write(NameLenght)

            bw.Write(tmp6)
            bw.Write(ServiceID_SID)
            bw.Write(tmp7)

            bw.Write(TransponderChannel2)

            bw.Write(tmp8)

            bw.Write(Frequency)

            bw.Write(tmp9)
            bw.Write(OriginalNetworkID_ONID)
            bw.Write(TransportStreamID_TSID)
            bw.Write(tmp10)
            bw.Write(TransponderChannel3)
            bw.Write(tmp11)

            x = CShort(Number2 Or &H4000)
            If isRadio Then
                bw.Write(x)
            Else
                bw.Write(Number2)
            End If

            bw.Write(tmp12)
            bw.Write(TransponderChannel4)
            bw.Write(tmp13)

            bw.Write(FavByte2)
            bw.Write(SkeepLockByte)
            bw.Write(ServiceID_SID2)

            bw.Write(tmp14)

            bw.Write(NameLenght2)

            'Name2
            For i As Integer = 0 To NameInFile2.Length - 1
                bw.Write(Convert.ToByte(Asc(NameInFile2.Substring(i, 1))))
            Next
            For i As Integer = 0 To 40 - 1 - NameInFile2.Length
                bw.Write(CByte(0))
            Next

            bw.Write(tmp15)
            bw.Write(AudioPid2)
            bw.Write(tmp16)

            Return ms.ToArray()

        End Function

        Public Function getListViewItem() As ListViewItem
            Dim lvw As New ListViewItem
            lvw.SubItems.Add(Me.Number.ToString)
            lvw.SubItems.Add(Me.DisplayName)
            lvw.SubItems.Add(Me.getShortName)
            lvw.SubItems.Add(Me.get_strFavoriten)
            lvw.SubItems.Add(Me.get_strSkip)
            lvw.SubItems.Add(Me.get_strLock)
            lvw.Tag = Me
            lvw.ImageKey = If(Me.isRadio, "Radio", "TV")
            Return lvw
        End Function

        Public Sub reloadListViewItem(lvw As ListViewItem)
            lvw.SubItems(1).Text = Me.Number.ToString
            lvw.SubItems(2).Text = Me.DisplayName
            lvw.SubItems(3).Text = Me.getShortName
            lvw.SubItems(4).Text = Me.get_strFavoriten
            lvw.SubItems(5).Text = Me.get_strSkip
            lvw.SubItems(6).Text = Me.get_strLock
        End Sub

        Public Function get_strFavoriten() As String
            Return If((Me.FavByte And DVBCT_Channel.ChannelFavoriten.A) = DVBCT_Channel.ChannelFavoriten.A, "A", "") & _
                                    If((Me.FavByte And DVBCT_Channel.ChannelFavoriten.B) = DVBCT_Channel.ChannelFavoriten.B, "B", "") & _
                                    If((Me.FavByte And DVBCT_Channel.ChannelFavoriten.C) = DVBCT_Channel.ChannelFavoriten.C, "C", "") & _
                                    If((Me.FavByte And DVBCT_Channel.ChannelFavoriten.D) = DVBCT_Channel.ChannelFavoriten.D, "D", "")
        End Function

        Public Function get_strSkip() As String
            Return If((Me.SkeepLockByte And DVBCT_Channel.ChannelSkipLockMode.Skip) = DVBCT_Channel.ChannelSkipLockMode.Skip, My.Resources.strYes, "")
        End Function

        Public Function get_strLock() As String
            Return If((Me.SkeepLockByte And DVBCT_Channel.ChannelSkipLockMode.Lock) = DVBCT_Channel.ChannelSkipLockMode.Lock, My.Resources.strYes, "")
        End Function

        Public Function getShortName() As String
            Dim r As String = String.Empty

            Dim TakeByte As Boolean = False
            For i As Integer = 0 To NameInFile.Length - 1
                If TakeByte AndAlso Asc(NameInFile.Substring(i, 1)) <> &H86 AndAlso Asc(NameInFile.Substring(i, 1)) <> &H87 AndAlso Asc(NameInFile.Substring(i, 1)) <> &H0 Then
                    r &= NameInFile.Substring(i, 1)
                End If

                If Asc(NameInFile.Substring(i, 1)) = &H86 Then
                    TakeByte = True
                End If
                If Asc(NameInFile.Substring(i, 1)) = &H87 Then
                    TakeByte = False
                End If
            Next

            Return r
        End Function

        Public Function getShortName2() As String
            Dim r As String = String.Empty

            Dim TakeByte As Boolean = False
            For i As Integer = 0 To NameInFile2.Length - 1
                If TakeByte AndAlso Asc(NameInFile2.Substring(i, 1)) <> &H86 AndAlso Asc(NameInFile2.Substring(i, 1)) <> &H87 AndAlso Asc(NameInFile2.Substring(i, 1)) <> &H0 Then
                    r &= NameInFile2.Substring(i, 1)
                End If

                If Asc(NameInFile2.Substring(i, 1)) = &H86 Then
                    TakeByte = True
                End If
                If Asc(NameInFile2.Substring(i, 1)) = &H87 Then
                    TakeByte = False
                End If
            Next

            Return r
        End Function

    End Class

End Namespace