﻿Namespace edank.LGTV.Channels

    Public Class LNB

        Private _DataBlock As Byte() 'gesamter DatenBlock

        '*************************
        'DatenBlock Parts
        Private _tmp1() As Byte '12
        Private _SettingID As Byte
        Private _tmp2() As Byte '3
        Private _SatelitteID As Byte
        Private _tmp3() As Byte '3
        Private _LNBFrequenceName As String
        Private _LOF1 As UInt16
        Private _tmp4() As Byte '2
        Private _LOF2 As UInt16
        Private tmp5() As Byte '6
        'EndDatenBlock Parts
        '****************************


        Public Sub New(Data() As Byte)
            _DataBlock = Data

            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)

            _tmp1 = br.ReadBytes(12)
            _SettingID = br.ReadByte
            _tmp2 = br.ReadBytes(3)
            _SatelitteID = br.ReadByte
            _tmp3 = br.ReadBytes(3)
            _LNBFrequenceName = System.Text.Encoding.Default.GetString(br.ReadBytes(&HC))
            _LNBFrequenceName = LNBFrequenceName.Replace(Chr(0), "")
            _LOF1 = br.ReadUInt16
            _tmp4 = br.ReadBytes(2)
            _LOF2 = br.ReadUInt16
            _tmp4 = br.ReadBytes(6)

            br.Close()
            ms.Close()
            ms.Dispose()


        End Sub

        Public ReadOnly Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
        End Property

        Public Property SettingID As Byte
            Get
                Return _SettingID
            End Get
            Set(value As Byte)
                _SettingID = value
            End Set
        End Property

        Public Property SatelitteID As Byte
            Get
                Return _SatelitteID
            End Get
            Set(value As Byte)
                _SatelitteID = value
            End Set
        End Property

        Public Property LNBFrequenceName As String
            Get
                Return _LNBFrequenceName
            End Get
            Set(value As String)
                _LNBFrequenceName = value.Replace(Chr(0), "")
            End Set
        End Property

        Public Property LOF1 As UInt16
            Get
                Return _LOF1
            End Get
            Set(value As UInt16)
                _LOF1 = value
            End Set
        End Property

        Public Property LOF2 As UInt16
            Get
                Return _LOF2
            End Get
            Set(value As UInt16)
                _LOF2 = value
            End Set
        End Property

 

        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

    End Class

End Namespace