﻿Namespace edank.LGTV.Channels

    Public Class DVBS_Indexes

        Private _DataBlock As Byte() 'gesamter DatenBlock

        '*************************
        'DatenBlock Parts
        Private _Index1 As UInt16
        Private _Index2 As UInt16
        Private _Index3 As UInt16
        Private _Index4 As UInt16
        'EndDatenBlock Parts
        '****************************


        Public Sub New(Data() As Byte)
            _DataBlock = Data

            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)

            _Index1 = br.ReadUInt16
            _Index2 = br.ReadUInt16
            _Index3 = br.ReadUInt16
            _Index4 = br.ReadUInt16

            br.Close()
            ms.Close()
            ms.Dispose()


        End Sub


#Region "Properties"

        Public ReadOnly Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
        End Property

        Public Property Index1 As UInt16
            Get
                Return _Index1
            End Get
            Set(value As UInt16)
                _Index1 = value
            End Set
        End Property

        Public Property Index2 As UInt16
            Get
                Return _Index2
            End Get
            Set(value As UInt16)
                _Index2 = value
            End Set
        End Property

        Public Property Index3 As UInt16
            Get
                Return _Index3
            End Get
            Set(value As UInt16)
                _Index3 = value
            End Set
        End Property

        Public Property Index4 As UInt16
            Get
                Return _Index4
            End Get
            Set(value As UInt16)
                _Index4 = value
            End Set
        End Property

#End Region


        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

        Public Function getBlockDatatoSave() As String
            Dim r As String = ""
            Dim d() As Byte = getDataToSave()
            For i As Integer = 0 To d.Length - 1
                r &= d(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

        Public Function getDataToSave() As Byte()

            Dim ms As New IO.MemoryStream()
            Dim bw As New IO.BinaryWriter(ms)

            bw.Write(Index1)
            bw.Write(Index2)
            bw.Write(Index3)
            bw.Write(Index4)

            Return ms.ToArray()

        End Function

    End Class
End Namespace
