﻿Namespace edank.LGTV.Menu
    Public Class Hotel

        Private _DataBlock As Byte() 'gesamter DatenBlock

        Private _HotelModeOperation As Byte
        Private _PowerOnStatus As ePowerOnStatus
        Private _SetupMenuDisplay As Byte
        Private _ProgramChange As Byte
        Private _InputSourceChange As Byte
        Private _MenuDisplay As Byte
        Private _OSDDisplay As Byte
        Private _LGIROperatation As Byte
        Private _LocalKeyOperation As Byte
        Private _MaxVolume As Byte
        Private _DTVChannelUpdate As eDTVChannelUpdate
        Private _PowerOnDefault As Byte
        Private _InputSource As eIOnputSource
        Private _Programme As UInt16
        Private _Volume As Byte
        Private _AVSetting As Byte
        Private _RadioVideoBlank As Byte
        Private tmp1() As Byte '1
        Private _StartPrNo As Byte
        Private tmp2() As Byte '1
        Private _NoOfPr As Byte
        Private _RadioNameDisplay As Byte
        Private tmp3() As Byte ' 2
        Private _HotelModeCodeInFile() As Byte
        Private _HotelModeCode As Integer

        Public Sub New(Data() As Byte)
            _DataBlock = Data

            Dim ms As New IO.MemoryStream(_DataBlock)
            Dim br As New IO.BinaryReader(ms)
            br.BaseStream.Seek(0, IO.SeekOrigin.Begin)

            _HotelModeOperation = br.ReadByte
            _PowerOnStatus = CType(br.ReadByte, ePowerOnStatus)
            _SetupMenuDisplay = br.ReadByte
            _ProgramChange = br.ReadByte
            _InputSourceChange = br.ReadByte
            _MenuDisplay = br.ReadByte
            _OSDDisplay = br.ReadByte
            _LGIROperatation = br.ReadByte
            _LocalKeyOperation = br.ReadByte
            _MaxVolume = br.ReadByte()
            _DTVChannelUpdate = CType(br.ReadByte, eDTVChannelUpdate)
            _PowerOnDefault = br.ReadByte()
            _InputSource = CType(br.ReadByte, eIOnputSource)
            _Programme = br.ReadUInt16
            _Volume = br.ReadByte
            _AVSetting = br.ReadByte
            _RadioVideoBlank = br.ReadByte
            tmp1 = br.ReadBytes(1)
            _StartPrNo = br.ReadByte
            tmp2 = br.ReadBytes(1)
            _NoOfPr = br.ReadByte
            _RadioNameDisplay = br.ReadByte
            tmp3 = br.ReadBytes(2)
            HotelModeCodeInFile = br.ReadBytes(4)

            br.Close()
            ms.Close()
            ms.Dispose()


        End Sub

        Public Property DataBlock As Byte()
            Get
                Return _DataBlock
            End Get
            Set(value As Byte())
                _DataBlock = value
            End Set
        End Property

        Public Property HotelModeOperation As Byte
            Get
                Return _HotelModeOperation
            End Get
            Set(value As Byte)
                _HotelModeOperation = value
            End Set
        End Property

        Public Property PowerOnStatus As ePowerOnStatus
            Get
                Return _PowerOnStatus
            End Get
            Set(value As ePowerOnStatus)
                _PowerOnStatus = value
            End Set
        End Property

        Public Property SetupMenuDisplay As Byte
            Get
                Return _SetupMenuDisplay
            End Get
            Set(value As Byte)
                _SetupMenuDisplay = value
            End Set
        End Property

        Public Property ProgramChange As Byte
            Get
                Return _ProgramChange
            End Get
            Set(value As Byte)
                _ProgramChange = value
            End Set
        End Property

        Public Property InputSourceChange As Byte
            Get
                Return _InputSourceChange
            End Get
            Set(value As Byte)
                _InputSourceChange = value
            End Set
        End Property

        Public Property MenuDisplay As Byte
            Get
                Return _MenuDisplay
            End Get
            Set(value As Byte)
                _MenuDisplay = value
            End Set
        End Property

        Public Property OSDDisplay As Byte
            Get
                Return _OSDDisplay
            End Get
            Set(value As Byte)
                _OSDDisplay = value
            End Set
        End Property

        Public Property LGIROperatation As Byte
            Get
                Return _LGIROperatation
            End Get
            Set(value As Byte)
                _LGIROperatation = value
            End Set
        End Property

        '0= Yes 1 = No
        Public Property LocalKeyOperation As Byte
            Get
                Return _LocalKeyOperation
            End Get
            Set(value As Byte)
                _LocalKeyOperation = value
            End Set
        End Property

        Public Property MaxVolume As Byte
            Get
                Return _MaxVolume
            End Get
            Set(value As Byte)
                _MaxVolume = value
            End Set
        End Property

        Public Property DTVChannelUpdate As eDTVChannelUpdate
            Get
                Return _DTVChannelUpdate
            End Get
            Set(value As eDTVChannelUpdate)
                _DTVChannelUpdate = value
            End Set
        End Property

        Public Property PowerOnDefault As Byte
            Get
                Return _PowerOnDefault
            End Get
            Set(value As Byte)
                _PowerOnDefault = value
            End Set
        End Property

        Public Property InputSource As eIOnputSource
            Get
                Return _InputSource
            End Get
            Set(value As eIOnputSource)
                _InputSource = value
            End Set
        End Property

        Public Property Programme As UInt16
            Get
                Return _Programme
            End Get
            Set(value As UInt16)
                _Programme = value
            End Set
        End Property

        Public Property Volume As Byte
            Get
                Return _Volume
            End Get
            Set(value As Byte)
                _Volume = value
            End Set
        End Property

        Public Property AVSetting As Byte
            Get
                Return _AVSetting
            End Get
            Set(value As Byte)
                _AVSetting = value
            End Set
        End Property

        Public Property RadioVideoBlank As Byte
            Get
                Return _RadioVideoBlank
            End Get
            Set(value As Byte)
                _RadioVideoBlank = value
            End Set
        End Property

        Public Property StartPrNo As Byte
            Get
                Return _StartPrNo
            End Get
            Set(value As Byte)
                _StartPrNo = value
            End Set
        End Property

        Public Property NoOfPr As Byte
            Get
                Return _NoOfPr
            End Get
            Set(value As Byte)
                _NoOfPr = value
            End Set
        End Property

        Public Property RadioNameDisplay As Byte
            Get
                Return _RadioNameDisplay
            End Get
            Set(value As Byte)
                _RadioNameDisplay = value
            End Set
        End Property






        Private Property HotelModeCodeInFile As Byte()
            Get
                Return _HotelModeCodeInFile
            End Get
            Set(value As Byte())
                _HotelModeCodeInFile = value
                _HotelModeCode = CInt(value(0).ToString & value(1).ToString & value(2).ToString & value(3).ToString)
            End Set
        End Property

        Public Property HotelModeCode As Integer
            Get
                Return _HotelModeCode
            End Get
            Set(value As Integer)
                _HotelModeCode = value
                For i As Integer = 0 To 3
                    _HotelModeCodeInFile(i) = CByte(value.ToString.Substring(i, 1))
                Next

            End Set
        End Property


        Public Function getDataToSave() As Byte()

            Dim ms As New IO.MemoryStream()
            Dim bw As New IO.BinaryWriter(ms)

            bw.Write(HotelModeOperation)
            bw.Write(PowerOnStatus)
            bw.Write(SetupMenuDisplay)
            bw.Write(ProgramChange)
            bw.Write(InputSourceChange)
            bw.Write(MenuDisplay)
            bw.Write(OSDDisplay)
            bw.Write(LGIROperatation)
            bw.Write(LocalKeyOperation)
            bw.Write(MaxVolume)
            bw.Write(DTVChannelUpdate)
            bw.Write(PowerOnDefault)
            bw.Write(InputSource)
            bw.Write(Programme)
            bw.Write(Volume)
            bw.Write(AVSetting)
            bw.Write(RadioVideoBlank)
            bw.Write(tmp1)
            bw.Write(StartPrNo)
            bw.Write(tmp2)
            bw.Write(NoOfPr)
            bw.Write(RadioNameDisplay)
            bw.Write(tmp3)
            bw.Write(HotelModeCodeInFile)
            Return ms.ToArray()

        End Function

        Public Enum ePowerOnStatus As Byte
            LSD = &H0
            STD = &H1
            PWR = &H2
        End Enum

        Public Enum eDTVChannelUpdate As Byte
            Manual = &H0
            Auto = &H1
        End Enum

        Public Enum eIOnputSource As Byte
            Off = &H0
            DTV = &H2
            Radio = &H3
            SDTV = &H7
            S_Radio = &H8
            AV1 = &H9
            HDMI1 = &H10
            HDMI2 = &H11
            HDMI3 = &H12
            HDMI4 = &H13
            AV2 = &HA
            AV3 = &HB
            Component = &HC
            RGB = &HF
        End Enum



        Public Function getBlockData() As String
            Dim r As String = ""
            For i As Integer = 0 To DataBlock.Length - 1
                r &= DataBlock(i).ToString("X2") & " "
            Next

            Return r.TrimEnd
        End Function

    End Class
End Namespace