﻿Imports edankTLL.edank.LGTV
Imports edankTLL.edank.LGTV.Channels

Public Class frmEncode

    Private Sub frmEncode_FormClosed(sender As Object, e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        DirectCast(Me.Owner, frmMain).chkHelpExtendet.Checked = False
    End Sub


    Private Sub frmEncode_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Call nudByteOffset_ValueChanged(Nothing, Nothing)
    End Sub

    Friend Sub nudByteOffset_ValueChanged(sender As System.Object, e As System.EventArgs) Handles nudByteChannelOffset.ValueChanged, nudByteTransponderOffset.ValueChanged, nudByteSatOffset.ValueChanged, nudByteLNBOffset.ValueChanged
        'Handles nudByteChannelOffset.ValueChanged, nudByteTransponderOffset.ValueChanged, nudByteSatOffset.ValueChanged, nudByteLNBOffset.ValueChanged

        Dim CurrentChannel As Object = DirectCast(Me.Owner, frmMain).currentChannel
        Select Case True
            Case TypeOf CurrentChannel Is DVBCT_Channel
                gpTransponder.Enabled = False
                gbSat.Enabled = False
                gbLNB.Enabled = False

                nudByteChannelOffset.Maximum = tll_ReadSave.DVBCT_ChannelLenght - 1

                Dim ctc As DVBCT_Channel = DirectCast(CurrentChannel, DVBCT_Channel)
                txt1ByteDec.Text = If(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value))) > 127, (ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value))) - 255).ToString, ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value))).ToString)
                txt1ByteDecUS.Text = ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value))).ToString

                txt2ByteDec.Text = BitConverter.ToInt16(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 2, nudByteChannelOffset.Value))).ToString
                txt2ByteDecUS.Text = BitConverter.ToUInt16(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 2, nudByteChannelOffset.Value))).ToString

                txt4ByteDec.Text = BitConverter.ToInt32(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 4, nudByteChannelOffset.Value))).ToString
                txt4ByteDecUS.Text = BitConverter.ToUInt32(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 4, nudByteChannelOffset.Value))).ToString

                txt8ByteDec.Text = BitConverter.ToInt64(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 8, nudByteChannelOffset.Value))).ToString
                txt8ByteDecUS.Text = BitConverter.ToUInt64(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 8, nudByteChannelOffset.Value))).ToString

                'ctc.DataBlock(CInt(nudByteOffset.Value)).ToString()
                txt1ByteChar.Text = Chr(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value))))

                txt1ByteBinary.Text = Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 4, nudByteChannelOffset.Value))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                      Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 3, nudByteChannelOffset.Value + 1))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                      Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 2, nudByteChannelOffset.Value + 2))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                      Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value + 3))), 2).PadLeft(8, CChar("0")).Insert(4, " ")


                lblToByte.Text = "To Byte  Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value)).ToString("X2")
                lblToInt16.Text = "To Int16 Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 2, nudByteChannelOffset.Value)).ToString("X2")
                lblToInt32.Text = "To Int32 Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 4, nudByteChannelOffset.Value)).ToString("X2")
                lblToInt64.Text = "To Int64 Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 8, nudByteChannelOffset.Value)).ToString("X2")
                lblToChar.Text = "To Char  Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 1, nudByteChannelOffset.Value)).ToString("X2")
                lblToBinary.Text = "To Bin   Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 4, nudByteChannelOffset.Value)).ToString("X2")



            Case TypeOf CurrentChannel Is DVBS_Channel
                gpTransponder.Enabled = True
                gbSat.Enabled = True
                gbLNB.Enabled = True

                nudByteChannelOffset.Maximum = tll_ReadSave.DVBS_ChannelLenght - 1


                Dim ctc As DVBS_Channel = DirectCast(CurrentChannel, DVBS_Channel)

                txt1ByteDec.Text = If(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value))) > 127, (ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value))) - 255).ToString, ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value))).ToString)
                txt1ByteDecUS.Text = ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value))).ToString

                txt2ByteDec.Text = BitConverter.ToInt16(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 2, nudByteChannelOffset.Value))).ToString
                txt2ByteDecUS.Text = BitConverter.ToUInt16(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 2, nudByteChannelOffset.Value))).ToString

                txt4ByteDec.Text = BitConverter.ToInt32(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 4, nudByteChannelOffset.Value))).ToString
                txt4ByteDecUS.Text = BitConverter.ToUInt32(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 4, nudByteChannelOffset.Value))).ToString

                txt8ByteDec.Text = BitConverter.ToInt64(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 8, nudByteChannelOffset.Value))).ToString
                txt8ByteDecUS.Text = BitConverter.ToUInt64(ctc.DataBlock, CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 8, nudByteChannelOffset.Value))).ToString

                'ctc.DataBlock(CInt(nudByteOffset.Value)).ToString()
                txt1ByteChar.Text = Chr(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value))))
                txt1ByteBinary.Text = Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 4, nudByteChannelOffset.Value))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                      Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 3, nudByteChannelOffset.Value + 1))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                      Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 2, nudByteChannelOffset.Value + 2))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                      Convert.ToString(ctc.DataBlock(CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value + 3))), 2).PadLeft(8, CChar("0")).Insert(4, " ")


                lblToByte.Text = "To Byte  Offset: " & CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value)).ToString("X2")
                lblToInt16.Text = "To Int16 Offset: " & CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 2, nudByteChannelOffset.Value)).ToString("X2")
                lblToInt32.Text = "To Int32 Offset: " & CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 4, nudByteChannelOffset.Value)).ToString("X2")
                lblToInt64.Text = "To Int64 Offset: " & CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 8, nudByteChannelOffset.Value)).ToString("X2")
                lblToChar.Text = "To Char  Offset: " & CInt(Math.Min(tll_ReadSave.DVBS_ChannelLenght - 1, nudByteChannelOffset.Value)).ToString("X2")
                lblToBinary.Text = "To Bin   Offset: " & CInt(Math.Min(tll_ReadSave.DVBCT_ChannelLenght - 4, nudByteChannelOffset.Value)).ToString("X2")



                'Transponder

                nudByteTransponderOffset.Maximum = tll_ReadSave.Transponder_Lenght - 1
                Dim ctt As Transponder = DirectCast(Me.Owner, frmMain).mytll_ReadSave.getTransponderById(ctc.TransponderID)

                txt1ByteDec_Transp.Text = If(ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value))) > 127, (ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value))) - 255).ToString, ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 2, nudByteTransponderOffset.Value + 1))).ToString)
                txt1ByteDecUS_Transp.Text = ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value))).ToString

                txt2ByteDec_Transp.Text = BitConverter.ToInt16(ctt.DataBlock, CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 2, nudByteTransponderOffset.Value))).ToString
                txt2ByteDecUS_Transp.Text = BitConverter.ToUInt16(ctt.DataBlock, CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 2, nudByteTransponderOffset.Value))).ToString

                txt4ByteDec_Transp.Text = BitConverter.ToInt32(ctt.DataBlock, CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 4, nudByteTransponderOffset.Value))).ToString
                txt4ByteDecUS_Transp.Text = BitConverter.ToUInt32(ctt.DataBlock, CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 4, nudByteTransponderOffset.Value))).ToString

                txt8ByteDec_Transp.Text = BitConverter.ToInt64(ctt.DataBlock, CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 8, nudByteTransponderOffset.Value))).ToString
                txt8ByteDecUS_Transp.Text = BitConverter.ToUInt64(ctt.DataBlock, CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 8, nudByteTransponderOffset.Value))).ToString

                txt1ByteChar_Transp.Text = Chr(ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value))))
                txt1ByteBinary_Transp.Text = Convert.ToString(ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 4, nudByteTransponderOffset.Value))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                             Convert.ToString(ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 3, nudByteTransponderOffset.Value + 1))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                             Convert.ToString(ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 2, nudByteTransponderOffset.Value + 2))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                             Convert.ToString(ctt.DataBlock(CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value + 3))), 2).PadLeft(8, CChar("0")).Insert(4, " ")



                lblToByte_Transp.Text = "To Byte  Offset: " & CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value)).ToString("X2")
                lblToInt16_Transp.Text = "To Int16 Offset: " & CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 2, nudByteTransponderOffset.Value)).ToString("X2")
                lblToInt32_Transp.Text = "To Int32 Offset: " & CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 4, nudByteTransponderOffset.Value)).ToString("X2")
                lblToInt64_Transp.Text = "To Int64 Offset: " & CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 8, nudByteTransponderOffset.Value)).ToString("X2")
                lblToChar_Transp.Text = "To Char  Offset: " & CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 1, nudByteTransponderOffset.Value)).ToString("X2")
                lblToBinary_Transp.Text = "To Bin   Offset: " & CInt(Math.Min(tll_ReadSave.Transponder_Lenght - 4, nudByteTransponderOffset.Value)).ToString("X2")


                'Sat

                nudByteSatOffset.Maximum = tll_ReadSave.Satelitte_Lenght - 1
                Dim cts As Satelitte = DirectCast(Me.Owner, frmMain).mytll_ReadSave.getSatelitteByIndex(ctt.SatelitteID)

                txt1ByteDec_Sat.Text = If(cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value))) > 127, _
                                          (cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value))) - 255).ToString, _
                                          cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value))).ToString)

                txt1ByteDecUS_Sat.Text = cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value))).ToString

                txt2ByteDec_Sat.Text = BitConverter.ToInt16(cts.DataBlock, CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 2, nudByteSatOffset.Value))).ToString
                txt2ByteDecUS_Sat.Text = BitConverter.ToUInt16(cts.DataBlock, CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 2, nudByteSatOffset.Value))).ToString

                txt4ByteDec_Sat.Text = BitConverter.ToInt32(cts.DataBlock, CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 4, nudByteSatOffset.Value))).ToString
                txt4ByteDecUS_Sat.Text = BitConverter.ToUInt32(cts.DataBlock, CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 4, nudByteSatOffset.Value))).ToString

                txt8ByteDec_Sat.Text = BitConverter.ToInt64(cts.DataBlock, CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 8, nudByteSatOffset.Value))).ToString
                txt8ByteDecUS_Sat.Text = BitConverter.ToUInt64(cts.DataBlock, CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 8, nudByteSatOffset.Value))).ToString

                txt1ByteChar_Sat.Text = Chr(cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value))))
                txt1ByteBinary_Sat.Text = Convert.ToString(cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 4, nudByteSatOffset.Value))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                          Convert.ToString(cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 3, nudByteSatOffset.Value + 1))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                          Convert.ToString(cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 2, nudByteSatOffset.Value + 2))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                          Convert.ToString(cts.DataBlock(CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value + 3))), 2).PadLeft(8, CChar("0")).Insert(4, " ")

                lblToByte_Sat.Text = "To Byte  Offset: " & CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 1, nudByteSatOffset.Value)).ToString("X2")
                lblToInt16_Sat.Text = "To Int16 Offset: " & CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 2, nudByteSatOffset.Value)).ToString("X2")
                lblToInt32_Sat.Text = "To Int32 Offset: " & CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 4, nudByteSatOffset.Value)).ToString("X2")
                lblToInt64_Sat.Text = "To Int64 Offset: " & CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 8, nudByteSatOffset.Value)).ToString("X2")
                lblToBinary_Sat.Text = "To Char  Offset: " & CInt(Math.Min(tll_ReadSave.Satelitte_Lenght - 4, nudByteSatOffset.Value)).ToString("X2")



                'LNB
                nudByteLNBOffset.Maximum = tll_ReadSave.LNB_Lenght - 1
                Dim lts As LNB = DirectCast(Me.Owner, frmMain).mytll_ReadSave.getLNB_ByIndex(ctt.SatelitteID)

                txt1ByteDec_LNB.Text = If(lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value))) > 127, _
                                          (lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value))) - 255).ToString, _
                                          lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value))).ToString)

                txt1ByteDecUS_LNB.Text = lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value))).ToString

                txt2ByteDec_LNB.Text = BitConverter.ToInt16(lts.DataBlock, CInt(Math.Min(tll_ReadSave.LNB_Lenght - 2, nudByteLNBOffset.Value))).ToString
                txt2ByteDecUS_LNB.Text = BitConverter.ToUInt16(lts.DataBlock, CInt(Math.Min(tll_ReadSave.LNB_Lenght - 2, nudByteLNBOffset.Value))).ToString

                txt4ByteDec_LNB.Text = BitConverter.ToInt32(lts.DataBlock, CInt(Math.Min(tll_ReadSave.LNB_Lenght - 4, nudByteLNBOffset.Value))).ToString
                txt4ByteDecUS_LNB.Text = BitConverter.ToUInt32(lts.DataBlock, CInt(Math.Min(tll_ReadSave.LNB_Lenght - 4, nudByteLNBOffset.Value))).ToString

                txt8ByteDec_LNB.Text = BitConverter.ToInt64(lts.DataBlock, CInt(Math.Min(tll_ReadSave.LNB_Lenght - 8, nudByteLNBOffset.Value))).ToString
                txt8ByteDecUS_LNB.Text = BitConverter.ToUInt64(lts.DataBlock, CInt(Math.Min(tll_ReadSave.LNB_Lenght - 8, nudByteLNBOffset.Value))).ToString

                txt1ByteChar_LNB.Text = Chr(lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value))))
                txt1ByteBinary_LNB.Text = Convert.ToString(lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 4, nudByteLNBOffset.Value))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                          Convert.ToString(lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 3, nudByteLNBOffset.Value + 1))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                          Convert.ToString(lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 2, nudByteLNBOffset.Value + 2))), 2).PadLeft(8, CChar("0")).Insert(4, " ") & "    " & _
                                          Convert.ToString(lts.DataBlock(CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value + 3))), 2).PadLeft(8, CChar("0")).Insert(4, " ")

                lblToByte_LNB.Text = "To Byte  Offset: " & CInt(Math.Min(tll_ReadSave.LNB_Lenght - 1, nudByteLNBOffset.Value)).ToString("X2")
                lblToInt16_LNB.Text = "To Int16 Offset: " & CInt(Math.Min(tll_ReadSave.LNB_Lenght - 2, nudByteLNBOffset.Value)).ToString("X2")
                lblToInt32_LNB.Text = "To Int32 Offset: " & CInt(Math.Min(tll_ReadSave.LNB_Lenght - 4, nudByteLNBOffset.Value)).ToString("X2")
                lblToInt64_LNB.Text = "To Int64 Offset: " & CInt(Math.Min(tll_ReadSave.LNB_Lenght - 8, nudByteLNBOffset.Value)).ToString("X2")
                lblToBinary_LNB.Text = "To Char  Offset: " & CInt(Math.Min(tll_ReadSave.LNB_Lenght - 4, nudByteLNBOffset.Value)).ToString("X2")


            Case Else


        End Select


    End Sub


End Class